package ru.alphatech.icfpc.policy;

import java.util.ArrayList;

import ru.alphatech.icfpc.cards.Get;
import ru.alphatech.icfpc.cards.I;
import ru.alphatech.icfpc.cards.K;
import ru.alphatech.icfpc.cards.Put;
import ru.alphatech.icfpc.cards.S;
import ru.alphatech.icfpc.cards.Zero;
import ru.alphatech.icfpc.game.AbstractPolicy;
import ru.alphatech.icfpc.game.Batch;
import ru.alphatech.icfpc.game.Run;
import ru.alphatech.icfpc.game.Slot;
import ru.alphatech.icfpc.game.Batch.OperationType;

public class CallExpressionPolicy extends AbstractPolicy{
	
	private int processSlotIndex = -1;
	private int sourceSlotIndex = -1;
	private int registerIndex = -1;
	private boolean execute = false;
	
	/**
	 * 
	 * @param processSlotIndex
	 * @param sourceSlot - откуда копируем функцию. если там не фукнция и execute = true результат с 99% ошибка
	 * @param execute - выполнить или просто скопировать в слот
	 */
	public CallExpressionPolicy(int processSlotIndex, int sourceSlot, int registerIndex, boolean execute) {
		this.processSlotIndex = processSlotIndex;
		this.sourceSlotIndex = sourceSlot;
		this.registerIndex = registerIndex;
		this.execute = execute;
	}
	
	protected boolean isStoreIdentityCard(Slot slot){
		if(slot.getValue() instanceof I){
			return true;
		}
		return false;
	}

	@Override
	public ArrayList<Batch> getBatches() {
		ArrayList<Batch> retArray = new ArrayList<Batch>();
		
		Slot processingSlot = Run.getProponent().getSlot(processSlotIndex);
		
		retArray.addAll(numberIntoSlotField(Run.getRegisterByIndex(registerIndex), sourceSlotIndex));
		
		if( ! isStoreIdentityCard(processingSlot) ){
			retArray.add(new Batch(OperationType.CARD_TO_SLOT, new Put(), processingSlot));
		}
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Get(), processingSlot));
		
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new K(), processingSlot));
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new S(), processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Get(), processingSlot));
		
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new K(), processingSlot));
		retArray.add(new Batch(OperationType.CARD_TO_SLOT, new S(), processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Get(), processingSlot));
		
		//корректировка по регистру
		retArray.addAll(correctRegister(registerIndex, processingSlot));
		
		retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Zero(), processingSlot));
		
		if(execute)
			retArray.add(new Batch(OperationType.SLOT_TO_CARD, new Zero(), processingSlot));
		
		return retArray;
	}
	
	
	
}
