package ru.alphatech.icfpc.policy;

import java.util.ArrayList;

import ru.alphatech.icfpc.game.AbstractPolicy;
import ru.alphatech.icfpc.game.Batch;

public abstract class CompositionPolicy extends AbstractPolicy{
	
	protected ArrayList<AbstractPolicy> policies = new ArrayList<AbstractPolicy>();

	protected void addPolicy(AbstractPolicy policy){
		policies.add(policy);
	}
	
	protected void removePolicy(AbstractPolicy policy){
		policies.remove(policy);
	}
	
	protected AbstractPolicy getPolicy(int index){
		return policies.get(index);
	}
	
	@Override
	public ArrayList<Batch> getBatches() {
		ArrayList<Batch> retArray = new ArrayList<Batch>();
		
		for(AbstractPolicy policy : policies){
			retArray.addAll(policy.getBatches());
		}
		
		return retArray;
	}
	
	
	
}
